cabal-version: 2.2
name:          Shpadoinkle-examples
version:       0.0.0.3
category:      Web
author:        Isaac Shapira
maintainer:    isaac.shapira@platonic.systems
license:       BSD-3-Clause
license-file:  LICENSE
build-type:    Simple
extra-source-files:
  README.md
synopsis:
  Example usages of Shpadoinkle
description:
  A collection of illustrative applications to show various Shpadoinkle utilities.


source-repository head
  type: git
  location: https://gitlab.com/platonic/shpadoinkle.git


common ghc-options
  ghc-options:
    -Wall
    -Wcompat
    -fwarn-redundant-constraints
    -fwarn-incomplete-uni-patterns
    -fwarn-tabs
    -fwarn-incomplete-record-updates
    -fwarn-identities


common ghcjs-options
  ghcjs-options:
    -Wall
    -Wcompat
    -fno-warn-missing-home-modules
    -fwarn-redundant-constraints
    -fwarn-incomplete-uni-patterns
    -fwarn-tabs
    -fwarn-incomplete-record-updates
    -fwarn-identities
    -dedupe
    -O2


executable animation
  import: ghc-options, ghcjs-options

  main-is: Animation.hs

  hs-source-dirs: ./.

  build-depends:
      Shpadoinkle
    , Shpadoinkle-backend-snabbdom
    , Shpadoinkle-html
    , base >=4.12.0 && <4.16
    , ease
    , ghcjs-dom
    , stm
    , text
    , unliftio

  default-language: Haskell2010


executable calculator
  import: ghc-options, ghcjs-options

  main-is: Calculator.hs

  hs-source-dirs: ./.
  build-depends:
      Shpadoinkle
    , Shpadoinkle-backend-pardiff
    , Shpadoinkle-html
    , Shpadoinkle-lens
    , Shpadoinkle-widgets
    , base >=4.12.0 && <4.16
    , lens
    , safe
    , text

  default-language: Haskell2010


executable calculator-ie
  import: ghc-options, ghcjs-options

  main-is: CalculatorIE.hs

  hs-source-dirs: ./.

  build-depends:
      Shpadoinkle
    , Shpadoinkle-backend-pardiff
    , Shpadoinkle-console
    , Shpadoinkle-html
    , Shpadoinkle-widgets
    , aeson
    , base >=4.12.0 && <4.16
    , file-embed
    , lens
    , safe
    , split
    , text

  default-language: Haskell2010


executable counter
  import: ghc-options, ghcjs-options

  main-is: Counter.hs

  hs-source-dirs: ./.

  build-depends:
      Shpadoinkle
    , Shpadoinkle-backend-pardiff
    , Shpadoinkle-html
    , base >=4.12.0 && <4.16
    , stm
    , text

  default-language: Haskell2010


executable lens
  import: ghc-options, ghcjs-options

  main-is: Lens.hs

  hs-source-dirs: ./.

  build-depends:
      Shpadoinkle
    , Shpadoinkle-backend-pardiff
    , Shpadoinkle-html
    , Shpadoinkle-lens
    , base >=4.12.0 && <4.16
    , generic-lens
    , lens
    , safe
    , text

  default-language: Haskell2010


executable servant-crud-client
  import: ghc-options, ghcjs-options

  main-is: Run/Client.hs

  other-modules:
    Types
    Types.Prim
    View
    Client

  hs-source-dirs: ./servant-crud

  build-depends:
      Shpadoinkle
    , Shpadoinkle-backend-pardiff
    , Shpadoinkle-backend-snabbdom
    , Shpadoinkle-html
    , Shpadoinkle-lens
    , Shpadoinkle-router
    , Shpadoinkle-widgets
    , aeson
    , base >=4.12.0 && <4.16
    , beam-core
    , bytestring
    , containers
    , exceptions
    , jsaddle
    , lens
    , mtl
    , servant
    , stm
    , text
    , unliftio

  if impl(ghcjs)
    build-depends:
        servant-client-js
  else
    build-depends:
        beam-sqlite
      , servant-client
      , sqlite-simple

  default-language: Haskell2010


executable servant-crud-dev
  import: ghc-options

  main-is: Run/Dev.hs

  other-modules:
    Types.Prim
    Types
    View
    Client
    Server

  hs-source-dirs: ./servant-crud

  build-depends:
      Shpadoinkle
    , Shpadoinkle-backend-pardiff
    , Shpadoinkle-backend-snabbdom
    , Shpadoinkle-backend-static
    , Shpadoinkle-html
    , Shpadoinkle-lens
    , Shpadoinkle-router
    , Shpadoinkle-widgets
    , aeson
    , base >=4.12.0 && <4.16
    , beam-core
    , beam-sqlite
    , bytestring
    , containers
    , exceptions
    , file-embed
    , generic-monoid
    , jsaddle
    , lens
    , mtl
    , optparse-applicative
    , servant
    , servant-server
    , sqlite-simple
    , stm
    , text
    , unliftio
    , wai
    , wai-app-static
    , warp

  if impl(ghcjs)
    buildable: False
  else
    buildable: True

  default-language: Haskell2010


executable servant-crud-server
  import: ghc-options

  main-is: Run/Server.hs

  other-modules:
    Types.Prim
    Types
    View
    Server

  hs-source-dirs: ./servant-crud

  build-depends:
      Shpadoinkle
    , Shpadoinkle-backend-static
    , Shpadoinkle-html
    , Shpadoinkle-lens
    , Shpadoinkle-router
    , Shpadoinkle-widgets
    , aeson
    , base >=4.12.0 && <4.16
    , beam-core
    , beam-sqlite
    , bytestring
    , containers
    , file-embed
    , lens
    , mtl
    , optparse-applicative
    , servant
    , servant-server
    , sqlite-simple
    , stm
    , text
    , wai
    , wai-app-static
    , warp

  if impl(ghcjs)
    buildable: False
  else
    buildable: True

  default-language: Haskell2010


executable streaming
  import: ghc-options, ghcjs-options

  main-is: Streaming.hs

  hs-source-dirs: ./.

  build-depends:
      Shpadoinkle
    , Shpadoinkle-backend-pardiff
    , Shpadoinkle-html
    , Shpadoinkle-streaming
    , base >=4.12.0 && <4.16
    , streaming
    , text

  default-language: Haskell2010


executable throttle-and-debounce
  import: ghc-options, ghcjs-options

  main-is: ThrottleAndDebounce.hs

  hs-source-dirs: ./.

  build-depends:
      Shpadoinkle
    , Shpadoinkle-backend-pardiff
    , Shpadoinkle-console
    , Shpadoinkle-html
    , base >=4.12.0 && <4.16
    , lens
    , safe
    , text

  default-language: Haskell2010


executable todomvc
  import: ghc-options, ghcjs-options

  main-is: TODOMVC.hs

  hs-source-dirs: ./.

  build-depends:
      Shpadoinkle
    , Shpadoinkle-backend-snabbdom
    , Shpadoinkle-html
    , Shpadoinkle-lens
    , base >=4.12.0 && <4.16
    , containers
    , generic-lens
    , lens
    , pretty-show
    , text

  default-language: Haskell2010


executable widgets
  import: ghc-options, ghcjs-options

  main-is: Widgets.hs

  hs-source-dirs: ./widgets

  build-depends:
      Shpadoinkle
    , Shpadoinkle-backend-pardiff
    , Shpadoinkle-backend-snabbdom
    , Shpadoinkle-html
    , Shpadoinkle-lens
    , Shpadoinkle-widgets
    , base >=4.12.0 && <4.16
    , lens
    , stm
    , text

  default-language: Haskell2010
